ALTER TABLE WEB_PAGE_TEMPLATE
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE WEB_PAGE_TEMPLATE P
SET P.ID_HASH = ORA_HASH (P.ID_WEB_PAGE_TEMPLATE || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE WEB_PAGE_TEMPLATE P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER WEB_PAGE_TEMPLATE_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON WEB_PAGE_TEMPLATE
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_WEB_PAGE_TEMPLATE || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

ALTER TABLE PAYMENT_LINK
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE PAYMENT_LINK P
SET P.ID_HASH = ORA_HASH (P.ID || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE PAYMENT_LINK P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER PAYMENT_LINK_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON PAYMENT_LINK
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2269, SYSDATE, '5.5', 2189, 'ID hash')
;